//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben 		*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************


//Routinen zum ansteuern der Netzwerkkarte 

// Schreibt ein Byte in ein angegebenes Register der Netzwerkkarte
void WriteRTL (char RTLADDR,char RTLDATA)
{
	char b;
	//Der Datenport wir auf output gesetzt vom C zum NIC schreiben
	data_ctlr_rtl = output;
	//write Adress to Port
	addr_port_rtl = (96 + RTLADDR);
	//write Data to Port
	data_port_rtl_write = RTLDATA;
	//set write Pin to Low
	cbi (addr_port_rtl,write_pin);
	//wait a short time
	for (int a=0;a<50;a++)
	{
	b++;
	}	
	//set write Pin to High
	sbi (addr_port_rtl,write_pin);	
	//write to RTL complete
}


// Auslesen eines Byte von einen angegebenes Register der Netzwerkkarte
int ReadRTL (char rtl_addr)
{
	char b;
	int rtl_data;
	//Der Datenport wir auf input gesetzt vom NIC zum C lesen
	data_ctlr_rtl = input;
	//write Adress to Port
	addr_port_rtl = (96 + rtl_addr);
	//set read Pin to Low
	cbi (addr_port_rtl , read_pin);
	//wait a short time	
	for (int a=0;a<50;a++)
	{
	b ++;
	}
	//read from port rtldata
	rtl_data = data_port_rtl_read;	
	//set Read Pin to High
	sbi (addr_port_rtl , read_pin);	
	//read from RTL complete
	return (rtl_data);
}

//Hier wird die Netzwerkkarte Grundinizialisiert
void Init_Realtek_Network_Card (void)
{
#if defined (__AVR_ATmega128__)
	//Set Addr Port Direction = Output
	data_addr_rtl = output;
#endif
	//Set all Addrport High
	addr_port_rtl = 255;
	//set Data Port Direction = Input
	data_ctlr_rtl = input;


	printf ("\n\n\n\nInit Network Card: ");

	//Set Reset Pin Low
	cbi (addr_port_rtl , reset_pin);		
	
	ReadRTL (rstport);
	WriteRTL (rstport , 0xFF);
	
	//wait a schort time
	for (int a = 0; a < 1000; a++)
		{
		}
	
	printf (".");			//Point 1
	WriteRTL (cr , 0x21);

	//wait a schort time	
	for (int a = 0; a < 1000; a++)
		{
		}
	
	printf (".");			//Point 2
	WriteRTL (dcr , dcrval);
	WriteRTL (rbcr0 , 0x00);
	WriteRTL (rbcr1 , 0x00);
	WriteRTL (rcr , 0x04);
	WriteRTL (tpsr , rxstart);
	WriteRTL (tcr , 0x02);
	WriteRTL (pstart , rxstart);
	WriteRTL (bnry , rxstart);
	WriteRTL (pstop , rxstop);
	WriteRTL (cr , 0x61);

	//wait a schort time	
	for (int a = 0; a < 1000; a++)
		{
		}

	printf (".");			//Point 3
	WriteRTL (curr , rxstart);
	
	for(int a = 0; a<=5; a++)
		{
		WriteRTL ((par0 + a) , mymac[a]);
		printf (".");		//Point 4,5,6,7,8,9
		}

	WriteRTL (cr , 0x21);
	WriteRTL (dcr , dcrval);
	WriteRTL (cr , 0x22);
	WriteRTL (isr , 0xFF);
	WriteRTL (imr , imrval);
	WriteRTL (tcr , tcrval);
	printf (" Init Ready! \n");
}


void Write_Ethernet_Frame (char *buffer,unsigned int bufferlen)
{
	if (bufferlen < 0x40)
		{
		for (int a = (bufferlen-4);a <= 0x44;a++)
			{
			buffer[a] = 0x20;
			}
		bufferlen = 0x40;
		}
		
	WriteRTL (cr,0x22);
	WriteRTL (tpsr,txstart);
	WriteRTL (rsar0,0x00);
	WriteRTL (rsar1,0x40);
	WriteRTL (isr,0xFF);
	WriteRTL (rbcr0,(bufferlen & 0x00ff) - 4);
	WriteRTL (rbcr1,(bufferlen & 0xff00) >>8);
	WriteRTL (cr,0x12);

	for (int a = 0; a < (bufferlen - 4);a++)
		{
		WriteRTL (rdmaport,buffer[a]);
		}
	
	//loop_until_bit_is_set(ReadRTL(isr),rdc);
	while ((ReadRTL(isr)&(1<<rdc)) == 0) {}

	WriteRTL (tbcr0,(bufferlen & 0x00ff) - 4);
	WriteRTL (tbcr1,(bufferlen & 0xff00) >>8);
	WriteRTL (cr,0x24);
}

void Read_Ethernet_Frame (char *buffer,int *bufferlen)
{
	unsigned char byte = 0;
	unsigned int tmp1;

	WriteRTL(0x00 , 0x1A);	
	ReadRTL(0x10);
	ReadRTL(0x10);
	tmp1 = ReadRTL(0x10);
	*bufferlen = (ReadRTL(0x10)<<8)+tmp1;
	  
	for (int a = 0; a <= *bufferlen; a++)
		{
		if (a <= 1500)
			{
			byte = ReadRTL (0x10);
			buffer[a] = byte;
			}
			else
			{
			byte = ReadRTL (0x10);
			}
		}	
	tmp1 = byte & rdc;
	
	if ( tmp1 != 64 )
		{
		ReadRTL(0x07);
		}
}

