//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben 	 	*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************

//Hier werden daten empfangen und geprft was empfangen wurde 
int get (void)
{
	//lnge des Ethernetpacketes
	unsigned int packetlen;

	//Array fr zu empfangene Daten und zu sendene Daten
	unsigned char packet[1500];

	//Lese daten aus NIC FIFO ins Array packet() sowie packetheader()
	Read_Ethernet_Frame (packet,&packetlen);	
	
	//wurde ein ARP packet empfangen?
	//2 Byte fr Nutzlastbereich (0806 fr ARP)
	if(packet[enetpacketType0] == 0x08 && packet[enetpacketType1] == 0x06)
		{
		//2 Byte Hardware Typ: Enthlt den Code fr Ethernet
		if(packet[arp_hwtype+1] == 0x01 &&

		//2 Byte Protokoll Typ: Enthlt den Code fr IP
		packet[arp_prtype] == 0x08 && packet[arp_prtype+1] == 0x00 &&

		//1Byte Lnge der Hardwareadresse:Enthlt 6 fr 6 Byte MAC Addresse
		packet[arp_hwlen] == 0x06 && 

		//1Byte Lnge der Protokolladresse:Enthlt 4 fr 4 Byte Adressen 
		packet[arp_prlen] == 0x04 &&

		//Operation handelt es sich um eine anfrage
		packet[arp_op+1] == 0x01 &&

		//Ist das ARP Packet fr meine IP Addresse bestimmt
		//Vergleiche ARP Target IP Adresse mit meiner IP
		MYIP[0] == packet[arp_tipaddr] &&
		MYIP[1] == packet[arp_tipaddr+1] &&
		MYIP[2] == packet[arp_tipaddr+2] &&
		MYIP[3] == packet[arp_tipaddr+3] )
			{
			//printf("ARP()\n");
			//Erzeugt ein ARP Reply Packet
			ARP_Reply(packet,&packetlen);
			}
		}
	
	//wurde ein ICMP, UDP oder TCP packet empfangen?
	//2 Byte fr Nutzlastbereich (0800 fr IP) 
	else if(packet[enetpacketType0] == 0x08 && packet[enetpacketType1] == 0x00

		//Ist das IP Packet fr meine IP Addresse bestimmt
		//Vergleiche IP Destaddr mit meiner IP
		&& packet[ip_destaddr] == MYIP[0]
		&& packet[ip_destaddr+1] == MYIP[1]
		&& packet[ip_destaddr+2] == MYIP[2]
		&& packet[ip_destaddr+3] == MYIP[3])
		{
		//Ist protokoll Byte = 1 dann ist es ein ICMP Packet
		if(packet[ip_proto] == PROT_ICMP)
			{
			//printf("ICMP()\n");
			//Erzeugt ein ICMP Reply Packet (PING Echo)
			ICMP_Reply(packet,packetlen);
			}
		
		//Ist protokoll Byte = 17 dann ist es ein UDP Packet
		else if(packet[ip_proto] == PROT_UDP)
			{
			printf("udp() \n");
			}
		//Ist protokoll Byte = 6 dann ist es ein TCP Packet
		else if(packet[ip_proto] == PROT_TCP)
			{

			//printf("tcp() \n");

			if (TCP_OPEN(packet,&packetlen)==1)
				{
				return(0);
				}
			
			if (packet[TCP_destport] == 0 && packet[TCP_destport+1] == 80)
				{
				httpd (packet,&packetlen);
				}
				
			if (packet[TCP_destport] == 0 && packet[TCP_destport+1] == 23)
				{
				telnet (packet,&packetlen);
				}
			}
	}
return (0);
}

SIGNAL (SIG_INTERRUPT4)
{
	//Globale Interrupts Ausschalten
	cli ();
	
	char ByteH;
	char ByteL;
	
	//Durchluft eine Schleife bis daten empfangen werden
	//loop_until_bit_is_set(PINE,INT4);			

	//if the receive buffer has been overrun
	ByteL = ReadRTL(isr);
	if ( (ByteL&(1<<ovw)) != 0)
		{
		printf ("Overrun!\n");
		}
		
	//gehe zu Routine GET wenn ein Packet empfangen wurde
	ByteL = ReadRTL(isr);
	if ( (ByteL & (1<<prx)) != 0)
		{
		get ();
		}
   
	//auslesen des Empfangsbuffer BNRY = CURR ist dieser gleich
	//mit Bufferauslesezhler dann ist der Buffer leer

	ByteL = ReadRTL(bnry); //auslesen NIC Register bnry
	WriteRTL ( cr , 0x62);

	ByteH = ReadRTL(curr); //auslesen NIC Register curr
	WriteRTL ( cr , 0x22);
		
	//NIC FIFO noch nicht leer
	//gehe zu Routine GET und lese ein weiteres Packet
	if (ByteL != ByteH) //(!= bedeutet ungleich)
		{
		get ();
		}
		
	//Zurcksetzen der Interrupt Bits des NIC
	WriteRTL (isr, 0xFF);
	
	//startet die Network Card
	WriteRTL (cr , 0x22);
	
	//Globale wieder Interrupts Einschalten
	sei ();
}
